Index: branches/1.3/gui/scripts/cloud.tcl
===================================================================
--- branches/1.3/gui/scripts/cloud.tcl	(revision 4501)
+++ branches/1.3/gui/scripts/cloud.tcl	(revision 4504)
@@ -149,6 +149,10 @@
         foreach {x y z} $line break
         foreach axis {x y z} units $_units {
-            set value [Rappture::Units::convert [set $axis] \
+            if { $units == "" } {
+                set value [set $axis]
+            } else {
+                set value [Rappture::Units::convert [set $axis] \
                         -context $units -to $units -units off]
+            }
             set $axis $value;           # Set the (x/y/z) coordinate to 
                                         # converted value.
Index: branches/1.3/gui/scripts/field.tcl
===================================================================
--- branches/1.3/gui/scripts/field.tcl	(revision 4501)
+++ branches/1.3/gui/scripts/field.tcl	(revision 4504)
@@ -1,4 +1,3 @@
 # -*- mode: tcl; indent-tabs-mode: nil -*- 
-
 # ----------------------------------------------------------------------
 #  COMPONENT: field - extracts data from an XML description of a field
@@ -82,4 +81,6 @@
                                         # valid data.
     private variable _isValidComponent; #  Array of valid components found
+    private variable _alwaysConvertDX 0;
+
     constructor {xmlobj path} { 
 	# defined below 
@@ -88,5 +89,5 @@
 	# defined below 
     }
-    public method blob { cname }
+    public method blob { cname }  
     public method components {args}
     public method controls {option args}
@@ -94,4 +95,5 @@
     public method numComponents {cname}
     public method fieldlimits {}
+    public method valueLimits { cname }
     public method flowhints { cname }
     public method hints {{key ""}}
@@ -150,4 +152,5 @@
 
     private method AvsToVtk { cname contents } 
+    private method DicomToVtk { cname contents } 
     private method BuildPointsOnMesh { cname } 
     protected method GetAssociation { cname } 
@@ -318,5 +321,5 @@
     }
     if {[info exists _comp2dx($cname)]} {
-        return ""  ;# no mesh -- it's embedded in the blob data
+        return ""  ;# no mesh -- it's embedded in the value data
     }
     if {[info exists _comp2mesh($cname)]} {
@@ -362,5 +365,5 @@
     }
     if {[info exists _comp2dx($cname)]} {
-        error "method \"values\" is not implemented for dx file data"
+        error "method \"values\" is not implemented for dx data"
     }
     if {[info exists _comp2unirect2d($cname)]} {
@@ -389,5 +392,5 @@
     }
     if {[info exists _comp2dx($cname)]} {
-        return $_comp2dx($cname)  ;# return gzipped, base64-encoded DX data
+        return $_comp2dx($cname)
     }
     if {[info exists _comp2unirect2d($cname)]} {
@@ -400,4 +403,11 @@
     }
     error "can't get field blob: Unknown component \"$cname\": should be one of [join [lsort [array names _comp2dims]] {, }]"
+}
+
+itcl::body Rappture::Field::valueLimits { cname } {
+    if { [info exists _comp2limits($cname)] } {
+        return $_comp2limits($cname)
+    }
+    return ""
 }
 
@@ -520,4 +530,5 @@
     return [list $min $max]
 }
+
 
 # ----------------------------------------------------------------------
@@ -789,4 +800,6 @@
         } elseif {[$_field element $cname.ucd] != ""} {
             set type "ucd"
+        } elseif {[$_field element $cname.dicom] != ""} {
+            set type "dicom"
 	}
         set _comp2style($cname) ""
@@ -894,32 +907,38 @@
             set _dim 3
             set _comp2dims($cname) "3D"
-            if { $_viewer != "nanovis" && $_viewer != "flowvis" } {
-                set vtkdata  [$_field get -decode yes $cname.$type]
-                if { $vtkdata == "" } {
-                    puts stderr "WARNING: No data for \"$_path.$cname.$type\""
-                    continue;               # Ignore this component
-                }
-                if 0 {
-                    set f [open /tmp/$_path.$cname.dx "w"]
-                    puts -nonewline $f $vtkdata
-                    close $f
-                }
-                set vtkdata  [Rappture::DxToVtk $vtkdata]
-                if 0 {
-                    set f [open /tmp/$_path.$cname.vtk "w"]
-                    puts -nonewline $f $vtkdata
-                    close $f
-                }
+            set data [$_field get -decode no $cname.$type]
+            set contents [Rappture::encoding::decode -as zb64 $data]
+            if { $contents == "" } {
+                puts stderr "WARNING: No data for \"$_path.$cname.$type\""
+                continue;               # Ignore this component
+            }
+            set vector ""
+            if 0 {
+                set f [open /tmp/$_path.$cname.dx "w"]
+                puts -nonewline $f $contents
+                close $f
+            }
+            # This is temporary.  I put a check for this in the DxToVtk
+            # parser.  
+            if { [string range $contents  0 3] == "<DX>" } {
+                set contents [string range $contents 4 end]
+            }
+            if { [catch { Rappture::DxToVtk $contents } vtkdata] == 0 } {
                 ReadVtkDataSet $cname $vtkdata
+            } else {
+                puts stderr "Can't parse dx data: $vtkdata"
+            }
+            if 0 {
+                set f [open /tmp/$_path.$cname.vtk "w"]
+                puts -nonewline $f $vtkdata
+                close $f
+            }
+            if { $_alwaysConvertDX ||
+                 ($_viewer != "nanovis" && $_viewer != "flowvis") } {
                 set _type "vtk"
                 set _comp2vtk($cname) $vtkdata
             } else {
-                set contents [$_field get -decode no $cname.$type]
-                if { $contents == "" } {
-                    puts stderr "WARNING: No data for \"$_path.$cname.$type\""
-                    continue;               # Ignore this component
-                }
                 set _type "dx"
-                set _comp2dx($cname) $contents
+                set _comp2dx($cname) $data
             }
             set _comp2style($cname) [$_field get $cname.style]
@@ -928,4 +947,21 @@
                     [Rappture::FlowHints ::\#auto $_field $cname $_units]
             }
+            set _dim 3
+            incr _counter
+        } elseif { $type == "dicom"} {
+            set contents [$_field get $cname.dicom]
+            if { $contents == "" } {
+                continue;               # Ignore this component
+            }
+            set viewer [$_field get "about.view"]
+            if { $viewer != "" } {
+                set _viewer $viewer
+            }
+            set vtkdata [DicomToVtk $cname $contents]
+            if { $_viewer == "" } {
+                set _viewer [expr {($_dim == 3) ? "vtkvolume" : "vtkimage"}]
+            }
+            set _comp2vtk($cname) $vtkdata
+            set _comp2style($cname) [$_field get $cname.style]
             incr _counter
         } elseif { $type == "ucd"} {
@@ -941,4 +977,5 @@
         }
         set _isValidComponent($cname) 1
+        #puts stderr "Field $cname type is: $_type"
     }
     if { [array size _isValidComponent] == 0 } {
@@ -1508,5 +1545,4 @@
 	# sort x-coords in increasing order
 	$xv sort $yv
-	
 	set _comp2dims($cname) "1D"
 	set _comp2xy($cname) [list $xv $yv]
@@ -1641,4 +1677,49 @@
     file delete $tmpfile
     return $vtkdata
+}
+
+itcl::body Rappture::Field::DicomToVtk { cname path } {
+    package require vtk
+
+    if { ![file exists $path] } {
+        puts stderr "path \"$path\" doesn't exist."
+        return 0
+    }
+
+    if { [file isdir $path] } {
+        set files [glob -nocomplain $path/*.dcm]
+        if { [llength $files] == 0 } {
+            set files [glob -nocomplain $path/*]
+            if { [llength $files] == 0 } {
+                puts stderr "no dicom files found in \"$path\""
+                return 0
+            }
+        }
+
+        #array set data [Rappture::DicomToVtk files $files]
+        array set data [Rappture::DicomToVtk dir $path]
+    } else {
+        array set data [Rappture::DicomToVtk files [list $path]]
+    }
+
+    foreach key [array names data] {
+        if {$key == "vtkdata"} {
+            if {1} {
+                set f [open /tmp/$cname.vtk "w"]
+                fconfigure $f -translation binary -encoding binary
+                puts -nonewline $f $data(vtkdata)
+                close $f
+            }
+        } else {
+            puts stderr "$key = \"$data($key)\""
+        }
+    }
+
+    # Save viewer choice
+    set viewer $_viewer
+    ReadVtkDataSet $cname $data(vtkdata)
+    # Restore viewer choice (ReadVtkDataSet wants to set it to contour/isosurface)
+    set _viewer $viewer
+    return $data(vtkdata)
 }
 
Index: branches/1.3/gui/scripts/fieldresult.tcl
===================================================================
--- branches/1.3/gui/scripts/fieldresult.tcl	(revision 4501)
+++ branches/1.3/gui/scripts/fieldresult.tcl	(revision 4504)
@@ -156,4 +156,8 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::FieldResult::add {dataobj {settings ""}} {
+    if { ![info exists itk_component(renderer)] } { 
+        puts stderr "add: no renderer created."
+        return
+    }
     eval $itk_component(renderer) add $dataobj [list $settings]
 }
@@ -166,4 +170,8 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::FieldResult::get {} {
+    if { ![info exists itk_component(renderer)] } { 
+        puts stderr "get: no renderer created."
+        return
+    }
     return [$itk_component(renderer) get]
 }
@@ -191,4 +199,8 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::FieldResult::scale {args} {
+    if { ![info exists itk_component(renderer)] } { 
+        puts stderr "scale: no renderer created."
+        return
+    }
     eval $itk_component(renderer) scale $args
 }
@@ -205,8 +217,16 @@
 # ----------------------------------------------------------------------
 itcl::body Rappture::FieldResult::download {option args} {
+    if { ![info exists itk_component(renderer)] } { 
+        puts stderr "download: no renderer created."
+        return
+    }
     eval $itk_component(renderer) download $option $args
 }
 
 itcl::body Rappture::FieldResult::snap { w h } {
+    if { ![info exists itk_component(renderer)] } { 
+        puts stderr "snap: no renderer created."
+        return
+    }
     return [$itk_component(renderer) snap $w $h]
 }
